Loading...
Searching...
No Matches
Ogre::HighLevelGpuProgram Class Referenceabstract
Core » Resources

Abstract base class representing a high-level program (a vertex or fragment program). More...

`#include <OgreHighLevelGpuProgram.h>`

Inheritance diagram for Ogre::HighLevelGpuProgram:
[legend]

## Public Member Functions

| HighLevelGpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor, should be used only by factory classes.
| ~HighLevelGpuProgram ()
GpuProgram * | _getBindingDelegate (void) override
| Returns the GpuProgram which should be bound to the pipeline.
size_t | calculateSize (void) const override
| Calculate the size of a resource; this will only be called after 'load'.
GpuProgramParametersSharedPtr | createParameters (void) override
| Creates a new parameters object compatible with this program definition.
const GpuNamedConstants & | getConstantDefinitions () override
| Get the full list of GpuConstantDefinition instances.
const String & | getEntryPoint (void) const
| Gets the entry point defined for this program.
const String & | getPreprocessorDefines (void) const
| Gets the preprocessor defines used to compile the program.
void | setEntryPoint (const String &entryPoint)
| Sets the entry point for this program i.e, the first method called.
void | setPreprocessorDefines (const String &defines)
| Sets the preprocessor defines used to compile the program.
Public Member Functions inherited from Ogre::GpuProgram
| GpuProgram (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
virtual | ~GpuProgram ()
uint32 | _getHash (uint32 seed=0) const
| internal method to get the microcode cache id
virtual const GpuProgramParametersPtr & | getDefaultParameters (void)
| Get a reference to the default parameters which are to be used for all uses of this program.
virtual const String & | getLanguage (void) const
| Returns a string that specifies the language of the gpu programs as specified in a material script.
const String & | getManualNamedConstantsFile () const
| Gets the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
virtual bool | getPassFogStates (void) const
| Returns whether a fragment program wants fog state to be passed through fixed pipeline low level API rendering calls (default true, subclasses can override).
virtual bool | getPassSurfaceAndLightStates (void) const
| Returns whether a vertex program wants light and material states to be passed through fixed pipeline low level API rendering calls (default false, subclasses can override).
virtual bool | getPassTransformStates (void) const
| Returns whether a vertex program wants transform state to be passed through fixed pipeline low level API rendering calls.
virtual const String & | getSource (void) const
| Gets the assembler source for this program.
const String & | getSourceFile (void) const
| Gets the name of the file used as source for this program.
const String & | getSyntaxCode (void) const
| Gets the syntax code for this program e.g.
GpuProgramType | getType (void) const
| Get the program type.
virtual bool | hasCompileError (void) const
| Did this program encounter a compile error when loading?
virtual bool | hasDefaultParameters (void) const
| Returns true if default parameters have been set up.
virtual bool | isSupported (void) const
| Returns whether this program can be supported on the current renderer and hardware.
virtual bool | isVertexTextureFetchRequired (void) const
| Returns whether this vertex program requires support for vertex texture fetch from the hardware.
virtual void | resetCompileError (void)
| Reset a compile error if it occurred, allowing the load to be retried.
void | setManualNamedConstants (const GpuNamedConstants &namedConstants)
| Allows you to manually provide a set of named parameter mappings to a program which would not be able to derive named parameters itself.
void | setManualNamedConstantsFile (const String &paramDefFile)
| Specifies the name of a file from which to load named parameters mapping for a program which would not be able to derive named parameters itself.
void | setSource (const String &source)
| Sets the source assembly for this program from an in-memory string.
void | setSourceFile (const String &filename)
| Sets the filename of the source assembly for this program.
void | setSyntaxCode (const String &syntax)
| Sets the syntax code for this program e.g.
void | setType (GpuProgramType t)
| Set the program type (only valid before load).
virtual void | setVertexTextureFetchRequired (bool r)
| Sets whether this vertex program requires support for vertex texture fetch from the hardware.
void | setInstancingIncluded (bool included)
| Sets whether a vertex program can do instancing.
bool | isInstancingIncluded (void) const
| Returns whether a vertex program can do instancing.
virtual void | setSkeletalAnimationIncluded (bool included)
| Sets whether a vertex program can do skeletal animation.
virtual bool | isSkeletalAnimationIncluded (void) const
| Returns whether a vertex program can do skeletal animation.
virtual void | setMorphAnimationIncluded (bool included)
| Sets whether a vertex program can do morph animation.
virtual void | setPoseAnimationIncluded (ushort poseCount)
| Sets whether a vertex program can do pose animation.
virtual bool | isMorphAnimationIncluded (void) const
| Returns whether a vertex program can do morph animation.
virtual bool | isPoseAnimationIncluded (void) const
| Returns whether a vertex program can do pose animation.
virtual ushort | getNumberOfPosesIncluded (void) const
| Returns the number of simultaneous poses the vertex program can blend, for use in pose animation.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Static Public Member Functions

static String | _resolveIncludes (const String &source, Resource *resourceBeingLoaded, const String &fileName, bool supportsFilename=false)
| Scan the source for #include and replace with contents from OGRE resources.
Static Public Member Functions inherited from Ogre::GpuProgram
static const String | getProgramTypeName (GpuProgramType programType)
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Additional Inherited Members

Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Detailed Description

Abstract base class representing a high-level program (a vertex or fragment program).

High-level programs are vertex and fragment programs written in a high-level language such as Cg or HLSL, and as such do not require you to write assembler code like GpuProgram does. However, the high-level program does eventually get converted (compiled) into assembler and then eventually microcode which is what runs on the GPU. As well as the convenience, some high-level languages like Cg allow you to write a program which will operate under both Direct3D and OpenGL, something which you cannot do with just GpuProgram (which requires you to write 2 programs and use each in a Technique to provide cross-API compatibility). Ogre will be creating a GpuProgram for you based on the high-level program, which is compiled specifically for the API being used at the time, but this process is transparent.

  You cannot create high-level programs direct - use HighLevelGpuProgramManager instead. Plugins can register new implementations of HighLevelGpuProgramFactory in order to add support for new languages without requiring changes to the core Ogre API. To allow custom parameters to be set, this class extends StringInterface - the application can query on the available custom parameters and get/set them without having to link specifically with it.

## Constructor & Destructor Documentation

## HighLevelGpuProgram()

Ogre::HighLevelGpuProgram::HighLevelGpuProgram | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Constructor, should be used only by factory classes.

## ~HighLevelGpuProgram()

Ogre::HighLevelGpuProgram::~HighLevelGpuProgram | ( |  | ) |

## Member Function Documentation

## createParameters()

GpuProgramParametersSharedPtr Ogre::HighLevelGpuProgram::createParameters | ( | void |  | ) |

override virtual

Creates a new parameters object compatible with this program definition.

Unlike low-level assembly programs, parameters objects are specific to the program and therefore must be created from it rather than by the HighLevelGpuProgramManager. This method creates a new instance of a parameters object containing the definition of the parameters this program understands.

Reimplemented from Ogre::GpuProgram.

## _getBindingDelegate()

GpuProgram * Ogre::HighLevelGpuProgram::_getBindingDelegate | ( | void |  | ) |

inline override virtual

Returns the GpuProgram which should be bound to the pipeline.

This method is simply to allow some subclasses of GpuProgram to delegate the program which is bound to the pipeline to a delegate, if required.

Reimplemented from Ogre::GpuProgram.

References Ogre::GpuProgram::GpuProgram().

## getConstantDefinitions()

const GpuNamedConstants & Ogre::HighLevelGpuProgram::getConstantDefinitions | ( |  | ) |

override virtual

Get the full list of GpuConstantDefinition instances.

Note
  Only available if this parameters object has named parameters.

Reimplemented from Ogre::GpuProgram.

## calculateSize()

size_t Ogre::HighLevelGpuProgram::calculateSize | ( | void |  | ) | const

override virtual

Calculate the size of a resource; this will only be called after 'load'.

Reimplemented from Ogre::GpuProgram.

## setPreprocessorDefines()

void Ogre::HighLevelGpuProgram::setPreprocessorDefines | ( | const String & | defines | ) |

inline

Sets the preprocessor defines used to compile the program.

## getPreprocessorDefines()

const String & Ogre::HighLevelGpuProgram::getPreprocessorDefines | ( | void |  | ) | const

inline

Gets the preprocessor defines used to compile the program.

## setEntryPoint()

void Ogre::HighLevelGpuProgram::setEntryPoint | ( | const String & | entryPoint | ) |

inline

Sets the entry point for this program i.e, the first method called.

## getEntryPoint()

const String & Ogre::HighLevelGpuProgram::getEntryPoint | ( | void |  | ) | const

inline

Gets the entry point defined for this program.

## _resolveIncludes()

String Ogre::HighLevelGpuProgram::_resolveIncludes | ( | const String & | source,
|  | Resource * | resourceBeingLoaded,
|  | const String & | fileName,
|  | bool | supportsFilename = false )

static

Scan the source for #include and replace with contents from OGRE resources.

The documentation for this class was generated from the following file:

- OgreHighLevelGpuProgram.h